// Agent initiator

/* Initial beliefs and rules */

part_num(50).
deadline(10000000).
initial_CFP(26). // check the initial values for dec_int!!!!

create_business_partners(List) :-
part_num(N) &
create_business_partners([], List, 1, N).

create_business_partners(CurrentL, List, CurrentN, N) :-
CurrentN < N &
.concat("participant", CurrentN, PartStr) &
.term2string(Part, PartStr) &
NewC = CurrentN +1 &
create_business_partners([Part|CurrentL], List, NewC, N).

create_business_partners(CurrentL, [Part|CurrentL], N, N) :-
.concat("participant", N, PartStr) &
.term2string(Part, PartStr).

monitor_name(monitor).

/* Initial goals */

!start.

/* Plans */

+!start : monitor_name(Monitor) 
   <- .send(Monitor, tell, start_conversation(icnp)).
   
+conversation_id(Name, CId)[source(Monitor)]:  
monitor_name(Monitor) 
& create_business_partners(List) 
& deadline(Delta)
& gtu.get_current_ms(MS2) & DL = MS2+Delta 
   <- -conversation_id(Name, CId); !my_broadcast(List, tell, m(cfp(DL), CId)).
   
+m(propose(PROPcurr, CurrentTime, DL), CId)[source(Participant)] : monitor_name(Monitor) & CurrentTime <= DL & initial_CFP(InitCFP)
   <- 
   -m(propose(PROPcurr, CurrentTime, DL), CId)[source(Participant)];
   +lastCFP(Participant, InitCFP);
   !my_send(Participant, tell, m(cfp(InitCFP, noDl), CId)).   

+m(propose(PROPcurr, noDl), CId)[source(Participant)] : monitor_name(Monitor) & lastCFP(Participant, Last) & P5 = PROPcurr + 5 & Last >= P5
   <- 
   -m(propose(PROPcurr, noDl), CId)[source(Participant)];
   !decrease(Participant, NewProp);
   !my_send(Participant, tell, m(cfp(NewProp, noDl), CId)).   
   
+m(propose(PROPcurr, noDl), CId)[source(Participant)] : monitor_name(Monitor) & lastCFP(Participant, Last) & P5 = PROPcurr + 5 & Last < P5
   <- 
   -m(propose(PROPcurr, noDl), CId)[source(Participant)];
   !my_send(Participant, tell, m(accept_proposal, CId)).    

      
+m(inform, CId)[source(Participant)] : monitor_name(Monitor) 
   <- 
   -m(inform, CId)[source(Participant)];
   .print("Agreement with ", Participant, " reached\n"). 
   
+!decrease(Participant, NewOffer) : lastCFP(Participant, Current) & NewOffer = Current-1 
   <- -lastCFP(Participant, Current); 
      +lastCFP(Participant, NewOffer).   
   
/* Plans for runtime type checking */

{include("./_session_tools.asl")}

