// Agent client

/* Initial beliefs and rules */

ongoing(a).
monitor_name(monitor).

initial_counter_offer(3).

+m(cfp(DL), CId)[source(Init)] : initial_counter_offer(Initial) & not(ongoing(CId)) & .my_name(Part)
   <-  -m(cfp(DL), CId)[source(Init)];
       +ongoing(CId);
       +current_counter_offer(Initial);
	   gtu.get_current_ms(CurrentTime);
       !my_send(Init, tell, m(propose(Initial, CurrentTime, DL), CId)).

// Plan for session compliant behaviour
+m(cfp(Prop, DL), CId)[source(Init)] : ongoing(CId) & .my_name(Part) 
   <- -m(cfp(Prop, DL), CId)[source(Init)]; 
      !increase(NewOffer);
      gtu.get_current_ms(CurrentTime);
       !my_send(Init, tell, m(propose(NewOffer,noDl), CId)). 
	   
+m(accept_proposal, CId)[source(Init)] : ongoing(CId) & .my_name(Part) 
   <- -m(accept_proposal, CId)[source(Init)];
      !my_send(Init, tell, m(inform, CId)).

// Plan for non session compliant behaviour, BUG1
/* +m(offer(Item, Offer), CId)[source(Buyer)] : true 
    <- -m(offer(Item, Offer), CId)[source(Buyer)];  
       !increase(Buyer, Item, NewOffer); 
       !my_send(Buyer, tell, m(offer(Item, NewOffer), CId));
	   !my_send(Buyer, tell, m(anotherOffer(Item, NewOffer), CId)). */

// Plan for non session compliant behaviour, BUG2 (uncomment initial goal)   
/* +!start : initial_counter_offer(Buyer, Item, Initial) 
   <-  -initial_counter_offer(Buyer, Item, Initial); 
       +current_counter_offer(Buyer, Item, Initial); 
       !my_send(Buyer, tell, m(counter(Item, Initial), s(0))). */ 	   
	   
+m(result(Res, Item, Offer), CId)[source(Buyer)]: true <- 
-m(result(Res, Item, Offer), CId)[source(Buyer)]; 
-current_counter_offer(_, _, _);
-ongoing(CId).

+!increase(NewOffer) : current_counter_offer(Current) & NewOffer = Current+1 
   <- -current_counter_offer(Current); 
      +current_counter_offer(NewOffer).


/* Plans for runtime type checking */

{include("./_session_tools.asl")}

